// ******************************************************************************
// * Licensed Materials - Property of IBM
// * 5724-W86, 5724-X63
// *  Copyright IBM Corporation 2008, 2012. All Rights Reserved.
// * US Government Users Restricted Rights- Use, duplication or disclosure
// * restricted by GSA ADP Schedule Contract with IBM Corp.
// ******************************************************************************
// *
// ******************************************************************************

// ******************************************************************************
// * Function processClasses
// ******************************************************************************
// * 
// ******************************************************************************
function processClasses(subElementClasses, subElement, record) {
	for ( var className in subElementClasses ) {
		if(subElementClasses.hasOwnProperty(className)) {
                         logMessage(4, "processClasses", "class: " + className, "record: " + record);
				var mynewelement = record.element;
				 
			if ( subElementClasses[className].filter(record, mynewelement) ) {
				processProperties(subElementClasses[className], subElement, record, mynewelement);
				processFormulas(subElementClasses[className], subElement, record, mynewelement);
			}
		} 
	var mynewelement = record.element;	
	}	
}


// ******************************************************************************
// * Function processProperties
// ******************************************************************************
// * 
// ******************************************************************************
function processProperties(subElementClass, subElement, record, mynewelement) {
	for ( var propertyName in subElementClass.properties ) {
		if(subElementClass.properties.hasOwnProperty(propertyName))
		{
			var value = subElementClass.properties[propertyName](record);
		logMessage(4, "processProperties", "propName: " + propertyName + "   propVal: " + value, "foo");
			addProperty(subElement, propertyName, value);
		}
	}
		
}


// ******************************************************************************
// * Function processFormulas
// ******************************************************************************
// * 
// ******************************************************************************
function processFormulas(subElementClass, subElement, record, mynewelement) {
//	var timestamp = subElementClass.timestamp(record) * 1;
//	above is commented out because we seem to be using date objects for metric 
//	timestamps now instead of epoch time
    var timestamp = subElementClass.timestamp(record);
	for ( var formulaName in subElementClass.formulas ) {
		if(isValid(record.key)) debug_remove_me=true;
		if(subElementClass.formulas.hasOwnProperty(formulaName))
		{
			var value = subElementClass.formulas[formulaName](record) * 1;
			addMetric(subElement, formulaName, timestamp, value);
		}
		
	}
}


// ******************************************************************************
// * Function addProperty
// ******************************************************************************
// * 
// ******************************************************************************
/*
function addProperty(subElement, name, value) {
	if (!isValueValid(value)) {
		return null;
	} 
	
	subElement.addProperty(name, value);
}
*/

// ******************************************************************************
// * Function addMetric
// ******************************************************************************
// * 
// ******************************************************************************
function addMetric(subElement, name, timestamp, value) {
	// if (!isValueValid(value) || isValueValid(value) == "false"  || isValueValid(value) == false ) {
		// return null;
	// } 
        if ( ! isValidNumber(value) ) {
           return null;
        }
 

	var metric = subElement.modelInterface.FloatMetric();
	metric.name = name;
	// Change for PMR 27081,012,649 and APAR IV19127, the CFHD related tablespaces are growing incrementally issue
	// metric.timestamp = timestamp;
	metric.value = value * 1; 	
	subElement.addMetric(metric);
}


// ******************************************************************************
// * Function isValueValid
// ******************************************************************************
// * 
// ******************************************************************************
function isValueValid(value) {
	if (value == undefined)
		return false;
        if ( value == null ) return false;
	if (value.toString() == "NaN")
		return false;
	if (value == "nil")
		return false;
	return true;
}

